--- u-boot-2011.06_original/lib/vsprintf.c	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/lib/vsprintf.c	2014-07-29 17:28:38.819972000 +0800
@@ -119,11 +119,34 @@
 	return simple_strtoul(cp,endp,base);
 }
 
-int ustrtoul(const char *cp, char **endp, unsigned int base)
+unsigned long ustrtoul(const char *cp, char **endp, unsigned int base)
 {
 	unsigned long result = simple_strtoul(cp, endp, base);
 	switch (**endp) {
-	case 'G' :
+	case 'G':
+		result *= 1024;
+		/* fall through */
+	case 'M':
+		result *= 1024;
+		/* fall through */
+	case 'K':
+	case 'k':
+		result *= 1024;
+		if ((*endp)[1] == 'i') {
+			if ((*endp)[2] == 'B')
+				(*endp) += 3;
+			else
+				(*endp) += 2;
+		}
+	}
+	return result;
+}
+
+unsigned long long ustrtoull(const char *cp, char **endp, unsigned int base)
+{
+	unsigned long long result = simple_strtoull(cp, endp, base);
+	switch (**endp) {
+	case 'G':
 		result *= 1024;
 		/* fall through */
 	case 'M':
diff '--exclude=.svn' -Naur u-boot-2011.06_original/lib/x_clib.c u-boot-2011.06/lib/x_clib.c
--- u-boot-2011.06_original/lib/x_clib.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/lib/x_clib.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,84 @@
+/*
+// Author: Jiasheng.chen@celestialsemi.com
+// Version0.1 Inital @2008.02.15
+*/
+
+#include <x_clib.h>
+
+void *x_memset(
+   void* dest,
+   int c, 
+   int count )
+{
+	int i = 0;
+	if (dest == NULL || count <=0)
+	{
+		return NULL;
+	}
+	while (i < count)
+	{
+		*((char *)dest + i) = (char)c;
+		i++;
+	}
+	return dest;
+}
+
+void *x_memcpy(
+   void *dest,
+   const void *src,
+   int count 
+)
+{
+	int i = 0;
+	if (count <=0)
+	{
+		return NULL;
+	}
+	for (i = 0; i < count ; i++)
+	{
+		*((char *)dest + i) = *((char *)src + i); 
+	}
+	return dest;
+}
+
+int  x_memcmp(const void* str1, const void* str2, int n)
+{
+    register unsigned char *s1 = (unsigned char*)str1;
+    register unsigned char *s2 = (unsigned char*)str2;
+	if (s1 == NULL || s2 == NULL)
+		return -1;
+    while (n-- > 0) {
+        if (*s1++ != *s2++)
+            return s1[-1] < s2[-1] ? -1 : 1;
+    }
+    return 0;
+}
+
+unsigned int udivsi3(unsigned int num, unsigned int den)
+{
+    unsigned int quot = 0, qbit = 1;
+
+    if ( den == 0 ) {
+        ///__divide_error();
+        return 0;			/* If trap returns... */
+    }
+
+    /* Left-justify denominator and count shift */
+    while ( (int)den >= 0 ) {
+        den <<= 1;
+        qbit <<= 1;
+    }
+
+    while ( qbit ) {
+        if ( den <= num ) {
+            num -= den;
+            quot += qbit;
+        }
+        
+        den >>= 1;
+        qbit >>= 1;
+    }
+
+    return quot;
+}
+
diff '--exclude=.svn' -Naur u-boot-2011.06_original/Makefile u-boot-2011.06/Makefile
--- u-boot-2011.06_original/net/eth.c	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/net/eth.c	2014-07-29 17:28:38.819972000 +0800
@@ -27,6 +27,8 @@
 #include <miiphy.h>
 #include <phy.h>
 
+extern int cn100_eth_readmac(bd_t *bd);
+
 void eth_parse_enetaddr(const char *addr, uchar *enetaddr)
 {
 	char *end;
@@ -206,6 +208,36 @@
 	return 0;
 }
 
+int eth_unregister(struct eth_device *dev)
+{
+	struct eth_device *cur;
+
+	/* No device */
+	if (!eth_devices)
+		return -1;
+
+	for (cur = eth_devices; cur->next != eth_devices && cur->next != dev;
+	     cur = cur->next)
+		;
+
+	/* Device not found */
+	if (cur->next != dev)
+		return -1;
+
+	cur->next = dev->next;
+
+	if (eth_devices == dev)
+		eth_devices = dev->next == eth_devices ? NULL : dev->next;
+
+	if (eth_current == dev) {
+		eth_current = eth_devices;
+		eth_current_changed();
+	}
+
+	return 0;
+}
+
+
 int eth_initialize(bd_t *bis)
 {
 	unsigned char env_enetaddr[6];
@@ -519,7 +551,7 @@
 
 #else /* !CONFIG_NET_MULTI */
 
-#warning Ethernet driver is deprecated.  Please update to use CONFIG_NET_MULTI
+//#warning Ethernet driver is deprecated.  Please update to use CONFIG_NET_MULTI
 
 extern int at91rm9200_miiphy_initialize(bd_t *bis);
 extern int mcf52x2_miiphy_initialize(bd_t *bis);
@@ -541,6 +573,9 @@
 #if defined(CONFIG_DRIVER_NS7520_ETHERNET)
 	ns7520_miiphy_initialize(bis);
 #endif
+#if defined(CONFIG_DRIVER_CN100)
+    cn100_eth_readmac(bis);
+#endif
 	return 0;
 }
 #endif
diff '--exclude=.svn' -Naur u-boot-2011.06_original/net/nfs.c u-boot-2011.06/net/nfs.c
--- u-boot-2011.06_original/net/nfs.c	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/net/nfs.c	2014-07-29 17:28:38.819972000 +0800
@@ -61,6 +61,10 @@
 static char *nfs_path;
 static char nfs_path_buff[2048];
 
+#ifdef CONFIG_CMD_SEC1900_MEM_PROTECT
+extern int check_write_to_code_area (unsigned long addr, unsigned long size);
+#endif
+
 static __inline__ int
 store_block (uchar * src, unsigned offset, unsigned len)
 {
@@ -85,6 +89,10 @@
 	} else
 #endif /* CONFIG_SYS_DIRECT_FLASH_NFS */
 	{
+#ifdef CONFIG_CMD_SEC1900_MEM_PROTECT
+		if (check_write_to_code_area ((unsigned long) (load_addr + offset), len))
+			return -1;
+#endif
 		(void)memcpy ((void *)(load_addr + offset), src, len);
 	}
 
diff '--exclude=.svn' -Naur u-boot-2011.06_original/net/tftp.c u-boot-2011.06/net/tftp.c
--- u-boot-2011.06_original/net/tftp.c	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/net/tftp.c	2014-07-29 17:28:38.819972000 +0800
@@ -150,6 +150,10 @@
 
 #endif	/* CONFIG_MCAST_TFTP */
 
+#ifdef CONFIG_CMD_SEC1900_MEM_PROTECT
+extern int check_write_to_code_area (unsigned long addr, unsigned long size);
+#endif
+
 static __inline__ void
 store_block(unsigned block, uchar *src, unsigned len)
 {
@@ -179,6 +183,12 @@
 	else
 #endif /* CONFIG_SYS_DIRECT_FLASH_TFTP */
 	{
+#ifdef CONFIG_CMD_SEC1900_MEM_PROTECT
+		if (check_write_to_code_area ((unsigned long) (load_addr + offset), len)) {
+			NetState = NETLOOP_FAIL;
+			return;
+		}
+#endif
 		(void)memcpy((void *)(load_addr + offset), src, len);
 	}
 #ifdef CONFIG_MCAST_TFTP
diff '--exclude=.svn' -Naur u-boot-2011.06_original/onenand_ipl/board/apollon/low_levelinit.S u-boot-2011.06/onenand_ipl/board/apollon/low_levelinit.S
--- u-boot-2011.06_original/tools/env/Makefile	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/tools/env/Makefile	2014-07-29 17:28:38.819972000 +0800
@@ -40,7 +40,7 @@
 
 # Some files complain if compiled with -pedantic, use HOSTCFLAGS_NOPED
 $(obj)fw_printenv:	$(HOSTSRCS) $(HEADERS)
-	$(HOSTCC) $(HOSTCFLAGS_NOPED) $(HOSTLDFLAGS) -o $@ $(HOSTSRCS)
+	 arm-linux-gnueabihf-gcc $(HOSTCFLAGS_NOPED) $(HOSTLDFLAGS) -o $@ $(HOSTSRCS)
 
 clean:
 	rm -f $(obj)fw_printenv $(obj)crc32.c
diff '--exclude=.svn' -Naur u-boot-2011.06_original/tools/Makefile u-boot-2011.06/tools/Makefile
--- u-boot-2011.06_original/tools/Makefile	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/tools/Makefile	2014-07-29 17:28:38.819972000 +0800
@@ -67,6 +67,7 @@
 BIN_FILES-$(CONFIG_CMD_LOADS) += img2srec$(SFX)
 BIN_FILES-$(CONFIG_INCA_IP) += inca-swap-bytes$(SFX)
 BIN_FILES-y += mkimage$(SFX)
+BIN_FILES-y += mkenvimage$(SFX)
 BIN_FILES-$(CONFIG_NETCONSOLE) += ncb$(SFX)
 BIN_FILES-$(CONFIG_SHA1_CHECK_UB_IMG) += ubsha1$(SFX)
 
@@ -89,6 +90,7 @@
 NOPED_OBJ_FILES-y += kwbimage.o
 NOPED_OBJ_FILES-y += imximage.o
 NOPED_OBJ_FILES-y += mkimage.o
+NOPED_OBJ_FILES-y += mkenvimage.o
 OBJ_FILES-$(CONFIG_NETCONSOLE) += ncb.o
 NOPED_OBJ_FILES-y += os_support.o
 OBJ_FILES-$(CONFIG_SHA1_CHECK_UB_IMG) += ubsha1.o
@@ -157,27 +159,27 @@
 all:	$(obj).depend $(BINS) $(LOGO-y) subdirs
 
 $(obj)bin2header$(SFX): $(obj)bin2header.o
-	$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o $@ $^
-	$(HOSTSTRIP) $@
+	$(Q)$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o $@ $^
+	$(Q)$(HOSTSTRIP) $@
 
 $(obj)bmp_logo$(SFX):	$(obj)bmp_logo.o
-	$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o $@ $^
-	$(HOSTSTRIP) $@
+	$(Q)$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o $@ $^
+	$(Q)$(HOSTSTRIP) $@
 
 $(obj)envcrc$(SFX):	$(obj)crc32.o $(obj)env_embedded.o $(obj)envcrc.o $(obj)sha1.o
-	$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o $@ $^
+	$(Q)$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o $@ $^
 
 $(obj)gen_eth_addr$(SFX):	$(obj)gen_eth_addr.o
-	$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o $@ $^
-	$(HOSTSTRIP) $@
+	$(Q)$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o $@ $^
+	$(Q)$(HOSTSTRIP) $@
 
 $(obj)img2srec$(SFX):	$(obj)img2srec.o
-	$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o $@ $^
-	$(HOSTSTRIP) $@
+	$(Q)$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o $@ $^
+	$(Q)$(HOSTSTRIP) $@
 
 $(obj)inca-swap-bytes$(SFX):	$(obj)inca-swap-bytes.o
-	$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o $@ $^
-	$(HOSTSTRIP) $@
+	$(Q)$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o $@ $^
+	$(Q)$(HOSTSTRIP) $@
 
 $(obj)mkimage$(SFX):	$(obj)crc32.o \
 			$(obj)default_image.o \
@@ -190,29 +192,35 @@
 			$(obj)os_support.o \
 			$(obj)sha1.o \
 			$(LIBFDT_OBJS)
-	$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o $@ $^
-	$(HOSTSTRIP) $@
+	$(Q)$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o $@ $^
+	$(Q)$(HOSTSTRIP) $@
+	
+$(obj)mkenvimage$(SFX): $(obj)crc32.o \
+			$(obj)mkenvimage.o \
+			$(LIBFDT_OBJS)
+	$(Q)$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o $@ $^
+	$(Q)$(HOSTSTRIP) $@
 
 $(obj)mpc86x_clk$(SFX):	$(obj)mpc86x_clk.o
-	$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o $@ $^
-	$(HOSTSTRIP) $@
+	$(Q)$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o $@ $^
+	$(Q)$(HOSTSTRIP) $@
 
 $(obj)ncb$(SFX):	$(obj)ncb.o
-	$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o $@ $^
-	$(HOSTSTRIP) $@
+	$(Q)$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o $@ $^
+	$(Q)$(HOSTSTRIP) $@
 
 $(obj)ubsha1$(SFX):	$(obj)os_support.o $(obj)sha1.o $(obj)ubsha1.o
 	$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o $@ $^
 
 # Some of the tool objects need to be accessed from outside the tools directory
 $(obj)%.o: $(SRCTREE)/common/%.c
-	$(HOSTCC) -g $(HOSTCFLAGS_NOPED) -c -o $@ $<
+	$(Q)$(HOSTCC) -g $(HOSTCFLAGS_NOPED) -c -o $@ $<
 
 $(obj)%.o: $(SRCTREE)/lib/%.c
-	$(HOSTCC) -g $(HOSTCFLAGS) -c -o $@ $<
+	$(Q)$(HOSTCC) -g $(HOSTCFLAGS) -c -o $@ $<
 
 $(obj)%.o: $(SRCTREE)/lib/libfdt/%.c
-	$(HOSTCC) -g $(HOSTCFLAGS_NOPED) -c -o $@ $<
+	$(Q)$(HOSTCC) -g $(HOSTCFLAGS_NOPED) -c -o $@ $<
 
 subdirs:
 ifeq ($(TOOLSUBDIRS),)
diff '--exclude=.svn' -Naur u-boot-2011.06_original/tools/mkenvimage.c u-boot-2011.06/tools/mkenvimage.c
--- u-boot-2011.06_original/tools/mkenvimage.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/tools/mkenvimage.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,314 @@
+/*
+ * (C) Copyright 2011 Free Electrons
+ * David Wagner <david.wagner@free-electrons.com>
+ *
+ * Inspired from envcrc.c:
+ * (C) Copyright 2001
+ * Paolo Scaffardi, AIRVENT SAM s.p.a - RIMINI(ITALY), arsenio@tin.it
+ *
+ * See file CREDITS for list of people who contributed to this
+ * project.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of
+ * the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+ * MA 02111-1307 USA
+ */
+
+/* We want the GNU version of basename() */
+#define _GNU_SOURCE
+
+#include <errno.h>
+#include <fcntl.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <stdint.h>
+#include <string.h>
+#include <unistd.h>
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <sys/mman.h>
+
+#include "compiler.h"
+#include <u-boot/crc.h>
+#include <version.h>
+
+#define CRC_SIZE sizeof(uint32_t)
+
+static void usage(const char *exec_name)
+{
+        fprintf(stderr, "%s [-h] [-r] [-b] [-p <byte>] -s <environment partition size> -o <output> <input file>\n"
+               "\n"
+               "This tool takes a key=value input file (same as would a `printenv' show) and generates the corresponding environment image, ready to be flashed.\n"
+               "\n"
+               "\tThe input file is in format:\n"
+               "\t\tkey1=value1\n"
+               "\t\tkey2=value2\n"
+               "\t\t...\n"
+               "\t-r : the environment has multiple copies in flash\n"
+               "\t-b : the target is big endian (default is little endian)\n"
+               "\t-p <byte> : fill the image with <byte> bytes instead of 0xff bytes\n"
+               "\t-V : print version information and exit\n"
+               "\n"
+               "If the input file is \"-\", data is read from standard input\n",
+               exec_name);
+}
+
+long int xstrtol(const char *s)
+{
+        long int tmp;
+
+        errno = 0;
+        tmp = strtol(s, NULL, 0);
+        if (!errno)
+                return tmp;
+
+        if (errno == ERANGE)
+                fprintf(stderr, "Bad integer format: %s\n",  s);
+        else
+                fprintf(stderr, "Error while parsing %s: %s\n", s,
+                                strerror(errno));
+
+        exit(EXIT_FAILURE);
+}
+
+int main(int argc, char **argv)
+{
+        uint32_t crc, targetendian_crc;
+        const char *txt_filename = NULL, *bin_filename = NULL;
+        int txt_fd, bin_fd;
+        unsigned char *dataptr, *envptr;
+        unsigned char *filebuf = NULL;
+        unsigned int filesize = 0, envsize = 0, datasize = 0;
+        int bigendian = 0;
+        int redundant = 0;
+        unsigned char padbyte = 0xff;
+
+        int option;
+        int ret = EXIT_SUCCESS;
+
+        struct stat txt_file_stat;
+
+        int fp, ep;
+        const char *prg;
+
+        prg = basename(argv[0]);
+
+        /* Turn off getopt()'s internal error message */
+        opterr = 0;
+
+        /* Parse the cmdline */
+        while ((option = getopt(argc, argv, ":s:o:rbp:hV")) != -1) {
+                switch (option) {
+                case 's':
+                        datasize = xstrtol(optarg);
+                        break;
+                case 'o':
+                        bin_filename = strdup(optarg);
+                        if (!bin_filename) {
+                                fprintf(stderr, "Can't strdup() the output filename\n");
+                                return EXIT_FAILURE;
+                        }
+                        break;
+                case 'r':
+                        redundant = 1;
+                        break;
+                case 'b':
+                        bigendian = 1;
+                        break;
+                case 'p':
+                        padbyte = xstrtol(optarg);
+                        break;
+                case 'h':
+                        usage(prg);
+                        return EXIT_SUCCESS;
+                case 'V':
+                        printf("%s version %s\n", prg, PLAIN_VERSION);
+                        return EXIT_SUCCESS;
+                case ':':
+                        fprintf(stderr, "Missing argument for option -%c\n",
+                                optopt);
+                        usage(prg);
+                        return EXIT_FAILURE;
+                default:
+                        fprintf(stderr, "Wrong option -%c\n", optopt);
+                        usage(prg);
+                        return EXIT_FAILURE;
+                }
+        }
+
+        /* Check datasize and allocate the data */
+        if (datasize == 0) {
+                fprintf(stderr, "Please specify the size of the environment partition.\n");
+                usage(prg);
+                return EXIT_FAILURE;
+        }
+
+        dataptr = malloc(datasize * sizeof(*dataptr));
+        if (!dataptr) {
+                fprintf(stderr, "Can't alloc %d bytes for dataptr.\n",
+                                datasize);
+                return EXIT_FAILURE;
+        }
+
+        /*
+         * envptr points to the beginning of the actual environment (after the
+         * crc and possible `redundant' byte
+         */
+        envsize = datasize - (CRC_SIZE + redundant);
+        envptr = dataptr + CRC_SIZE + redundant;
+
+        /* Pad the environment with the padding byte */
+        memset(envptr, padbyte, envsize);
+
+        /* Open the input file ... */
+        if (optind >= argc || strcmp(argv[optind], "-") == 0) {
+                int readbytes = 0;
+                int readlen = sizeof(*envptr) * 4096;
+                txt_fd = STDIN_FILENO;
+
+                do {
+                        filebuf = realloc(filebuf, readlen);
+                        if (!filebuf) {
+                                fprintf(stderr, "Can't realloc memory for the input file buffer\n");
+                                return EXIT_FAILURE;
+                        }
+                        readbytes = read(txt_fd, filebuf + filesize, readlen);
+                        if (errno) {
+                                fprintf(stderr, "Error while reading stdin: %s\n",
+                                                strerror(errno));
+                                return EXIT_FAILURE;
+                        }
+                        filesize += readbytes;
+                } while (readbytes == readlen);
+
+        } else {
+                txt_filename = argv[optind];
+                txt_fd = open(txt_filename, O_RDONLY);
+                if (txt_fd == -1) {
+                        fprintf(stderr, "Can't open \"%s\": %s\n",
+                                        txt_filename, strerror(errno));
+                        return EXIT_FAILURE;
+                }
+                /* ... and check it */
+                ret = fstat(txt_fd, &txt_file_stat);
+                if (ret == -1) {
+                        fprintf(stderr, "Can't stat() on \"%s\": %s\n",
+                                        txt_filename, strerror(errno));
+                        return EXIT_FAILURE;
+                }
+
+                filesize = txt_file_stat.st_size;
+
+                filebuf = mmap(NULL, sizeof(*envptr) * filesize, PROT_READ,
+                               MAP_PRIVATE, txt_fd, 0);
+                if (filebuf == MAP_FAILED) {
+                        fprintf(stderr, "mmap (%zu bytes) failed: %s\n",
+                                        sizeof(*envptr) * filesize,
+                                        strerror(errno));
+                        fprintf(stderr, "Falling back to read()\n");
+
+                        filebuf = malloc(sizeof(*envptr) * filesize);
+                        ret = read(txt_fd, filebuf, sizeof(*envptr) * filesize);
+                        if (ret != sizeof(*envptr) * filesize) {
+                                fprintf(stderr, "Can't read the whole input file (%zu bytes): %s\n",
+                                        sizeof(*envptr) * filesize,
+                                        strerror(errno));
+
+                                return EXIT_FAILURE;
+                        }
+                }
+                ret = close(txt_fd);
+        }
+        /* The +1 is for the additionnal ending \0. See below. */
+        if (filesize + 1 > envsize) {
+                fprintf(stderr, "The input file is larger than the environment partition size\n");
+                return EXIT_FAILURE;
+        }
+
+        /* Replace newlines separating variables with \0 */
+        for (fp = 0, ep = 0 ; fp < filesize ; fp++) {
+                if (filebuf[fp] == '\n') {
+                        if (ep == 0) {
+                                /*
+                                 * Newlines at the beginning of the file ?
+                                 * Ignore them.
+                                 */
+                                continue;
+                        } else if (filebuf[fp-1] == '\\') {
+                                /*
+                                 * Embedded newline in a variable.
+                                 *
+                                 * The backslash was added to the envptr; rewind
+                                 * and replace it with a newline
+                                 */
+                                ep--;
+                                envptr[ep++] = '\n';
+                        } else {
+                                /* End of a variable */
+                                envptr[ep++] = '\0';
+                        }
+                } else {
+                        envptr[ep++] = filebuf[fp];
+                }
+        }
+        /*
+         * Make sure there is a final '\0'
+         * And do it again on the next byte to mark the end of the environment.
+         */
+        if (envptr[ep-1] != '\0') {
+                envptr[ep++] = '\0';
+                /*
+                 * The text file doesn't have an ending newline.  We need to
+                 * check the env size again to make sure we have room for two \0
+                 */
+                if (ep >= envsize) {
+                        fprintf(stderr, "The environment file is too large for the target environment storage\n");
+                        return EXIT_FAILURE;
+                }
+                envptr[ep] = '\0';
+        } else {
+                envptr[ep] = '\0';
+        }
+
+        /* Computes the CRC and put it at the beginning of the data */
+        crc = crc32(0, envptr, envsize);
+        targetendian_crc = bigendian ? cpu_to_be32(crc) : cpu_to_le32(crc);
+
+        memcpy(dataptr, &targetendian_crc, sizeof(targetendian_crc));
+        if (redundant)
+                dataptr[sizeof(targetendian_crc)] = 1;
+
+        if (!bin_filename || strcmp(bin_filename, "-") == 0) {
+                bin_fd = STDOUT_FILENO;
+        } else {
+                bin_fd = creat(bin_filename, S_IRUSR | S_IWUSR | S_IRGRP |
+                                             S_IWGRP);
+                if (bin_fd == -1) {
+                        fprintf(stderr, "Can't open output file \"%s\": %s\n",
+                                        bin_filename, strerror(errno));
+                        return EXIT_FAILURE;
+                }
+        }
+
+        if (write(bin_fd, dataptr, sizeof(*dataptr) * datasize) !=
+                        sizeof(*dataptr) * datasize) {
+                fprintf(stderr, "write() failed: %s\n", strerror(errno));
+                return EXIT_FAILURE;
+        }
+
+        ret = close(bin_fd);
+
+        return ret;
+}
+
diff '--exclude=.svn' -Naur u-boot-2011.06_original/tools/setlocalversion u-boot-2011.06/tools/setlocalversion
--- u-boot-2011.06_original/tools/setlocalversion	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/tools/setlocalversion	2014-07-29 17:28:38.819972000 +0800
@@ -32,7 +32,8 @@
 
 # Check for svn and a svn repo.
 if rev=`svn info 2>/dev/null` ; then
-	rev=`echo "${rev}" | grep '^Revision' | awk '{print $NF}'`
+	#rev=`echo "${rev}" | grep '^Revision' | awk '{print $NF}'`
+	rev=`svnversion -n`
 	printf -- '-svn%s' $rev
 fi
 
